  bind msgm - * kbonjoin

#------------------------------------------------------------------------------------------------------------
# This Proc parts and joins the approved channels in order to weed out onjoins and onparts
#------------------------------------------------------------------------------------------------------------
if {[info exists spamtimer] == 0} {
   putlog "\0033 SpamCheck Timer Started"
   set spamtimer "in use"
   timer 20 {do:spampart}
}

proc do:spampart {} {
    global spamcheck_chans
    foreach chan [channels] {
      set chan [string tolower $chan]
      if {[string first " $chan " $spamcheck_chans] != -1} { 
        putlog "\0035 Weeding out onjoins in $chan"
        channel set $chan +inactive
      }
    }
utimer 15 {do:spamjoin}
}

proc do:spamjoin {} {
    global spamcheck_chans
    foreach chan [channels] {
      if {[string first " $chan " $spamcheck_chans] != -1} { 
        channel set $chan -inactive
      }
    }
    timer 15 {do:spampart}
}

#------------------------------------------------------------------------------------------------------------
# This Proc bans anyone using any invite script defined in netset.tcl
#------------------------------------------------------------------------------------------------------------
proc kbonjoin {nick uhost hand rest} {
   global invitekickmsg delaychanoj delaynickoj delayuhostoj spamtriggers spambantime spamwarnings
       if {[matchattr $hand o]} {return 0}
       if {[matchattr $hand b]} {return 0}
       foreach trigger $spamtriggers {
         if [string match [string tolower $trigger] [string tolower $rest]] {
	       putlog "\0033 Onjoin detected by $nick, running ban script ($trigger)"
	       foreach chan [channels] {
		  if [onchan $nick $chan] {
                        if {[isop $nick $chan]} {return 0}
			if [botisop $chan] {
			   putlog "\0033 Banning $nick for running an onjoin"
			   set mask [getmask $nick $chan]
			   warnban $nick $mask $chan $spambantime $spamwarnings $invitekickmsg
			   return 1
			} else {
			   set delaychanoj $chan
			   set delaynickoj $nick
			   set delayuhostoj $uhost
			   utimer 20 {do:delayedkb}
			   return 0
			   }
		  }
	       }
	 }
       }

} 

proc do:delayedkb {} {
   global delaychanoj delaynickoj delayuhostoj invitekickmsg $spambantime $spamwarnings
         if [botisop $delaychanoj] {
            putlog "\0033 No Ops, Delaying Banning $delaynickoj for onjoin"
            set mask [getmask $delaynickoj $delaychanoj]
            warnban $delaynickoj $mask $delaychanoj $spambantime $spamwarnings $invitekickmsg
	    return 1
         } else {
	    utimer 20 {do:delayedkb}
	 }
} 

